$(document).ready(function(){

	//=================================================
	// Variables
	//=================================================
	var websock;
	var esp_adress = "esp_board_1.local";
	var esp_socket_port = "81";

	//=================================================
	// Prefill GUI
	//=================================================
	$(".device_adress").val(esp_adress);

	//=================================================
	// Setup GUI elements
	//=================================================
	$( "#var1_slider" ).slider({
		value:-1,
		min:-1,
		max:6,
		change: function(event,ui){
									$("#var1").html(ui.value);
									sendSlidersValues();
								  }
	});
	
	$( "#var2_slider" ).slider({
		value:5,
		min:1,
		max:20,
		change: function(event,ui){
									$("#var2").html(ui.value);
									sendSlidersValues();
								  }
	});
	$( "#var3_slider" ).slider({
		value:10,
		min:1,
		max:10,
		change: function(event,ui){
									$("#var3").html(ui.value);
									sendSlidersValues();
								  }
	});
	
	//=================================================
	// Bindings
	//=================================================
	$('.button_with_id').on("click",function(){
		buttonWithIDClicked($(this));
	});
	$('.button1').on("click",function(){
		button1Clicked();
	});
	$('.button2').on("click",function(){
		button2Clicked();
	});
	$('.button3').on("click",function(){
		button3Clicked();
	});
	$('.button4').on("click",function(){
		button4Clicked();
	});
	$('.button5').on("click",function(){
		button5Clicked();
	});
	$('.button6').on("click",function(){
		button6Clicked();
	});

	$('.connect_to_esp').on("click",function(){
		connectToEsp();
	});
	

	//=================================================	 
	// Methods declaration
	//=================================================

	function sendSlidersValues(){
		var color_id = $("#var1").text();
		var count    = $("#var2").text();
		var freq     = $("#var3").text();
		if(color_id!=""&&count!=""&&freq!="")
		$.get( "http://" + esp_adress + "/blink",{color_id:color_id,count:count,freq:freq}, function( data ) {});
	};

	function buttonWithIDClicked(e){
		console.log("button with id", e.attr('id')," clicked");
	};

	function button1Clicked(){
		$.get("http://" + esp_adress + "/activate_leds?led_id=-1&state=1&color_id=1", function( data ) {});
	};
	function button2Clicked(){
		$.get("http://" + esp_adress + "/activate_leds?led_id=-1&state=1&color_id=2", function( data ) {});
	};
	function button3Clicked(){
		$.get("http://" + esp_adress + "/activate_leds?led_id=-1&state=1&color_id=3", function( data ) {});
	};
	function button4Clicked(){
		$.get("http://" + esp_adress + "/activate_leds?led_id=-1&state=0&color_id=3", function( data ) {});
	};
	function button5Clicked(){
		console.log("button5 clicked");
		$.get( "http://" + esp_adress + "/animate_leds",{name:"EdgeToCenter",speed:"6"}, function( data ) {});
	};
	function button6Clicked(){
		console.log("button5 clicked");
		$.get( "http://" + esp_adress + "/vibrate",{arg1:var1,arg2:var2,arg3:var3}, function( data ) {});
	};


	function connectToEsp(){
		console.log("connectToEsp");
		esp_adress = $(".device_adress").val();
		start_socket();

	};
	
	//=================================================	 
	// SOCKET
	//=================================================
	function start_socket(){
	
	  var url = "ws://" + esp_adress + ":" + esp_socket_port + "/";
	  websock = new WebSocket(url);
	  console.log("Trying to open websocket at: ", url);

	  websock.onopen = function(evt) { console.log('websocket OPEN!'); };
	  websock.onclose = function(evt) {
			var mess = 'websocket closed!';  
			console.log(mess); 
			var e = document.getElementById('mess_from_ESP');
			e.textContent = mess;
		
	  };
	  websock.onerror = function(evt) { console.log(evt); };
	  websock.onmessage = function(evt) {
		//console.log(evt);
		var e = document.getElementById('mess_from_ESP');
		e.textContent = evt.data.substring(0,50) + "...";
	  };
	};
	
	
});